# Resources

A few resources that are helpful for building with Slate.

## Libraries

These libraries are helpful when developing with Slate:

- [`is-hotkey`](https://github.com/ianstormtaylor/is-hotkey) is a simple way to check whether an `onKeyDown` handler should fire for a given hotkey, handling cross-platform concerns like cmd vs. ctrl keys for you automatically.

## Extensions and Plugins

These extensions and plugins add additional features and capabilities to Slate:

- [Plate](https://github.com/udecode/plate) Rich text editor plugin system for Slate & React
- [`slate-angular`](https://github.com/worktile/slate-angular) Angular-based view layer, which is a useful supplement to Slate for building a rich text editor using Angular.
- [`slate-yjs`](https://github.com/BitPhinix/slate-yjs/) Collaborative editing utilities for Slate leveraging Yjs
- [`slate-collaborative`](https://github.com/cudr/slate-collaborative) Collaborative editing utilities for Slate leveraging Automerge

## Products

These products use Slate, and can give you an idea of what's possible:

- [Aline](https://www.aline.co/): Digital contracting for the modern enterprise
- [Archbee](https://archbee.io/): Build better product docs with your team
- [Campfire](https://www.campfirewriting.com/): The most versatile writing software [for fiction]
- [Chatterbug](https://chatterbug.com/): Learn languages from real people
- [CoCalc](https://cocalc.com/): Collaborative calculation and data science
- [Coda](https://coda.io/): Coda brings all your words, data, and teamwork into one powerful doc
- [Dropdeck](https://www.dropdeck.com/): Magically create beautiful slides — faster than ever
- [Eraser](https://www.tryeraser.com/): The Whiteboard for Engineering Teams
- [GitBook](https://www.gitbook.com/): Plan, centralize and share knowledge
- [Discord](https://discord.com/): Text & voice channels to collaborate & share
- [Grafana](https://grafana.com/): Operational dashboards for your data
- [Guilded](https://www.guilded.gg/): Better chat, happier communities
- [Guru](https://www.getguru.com/): Organize company information. Access it anywhere. [wiki]
- [Hygraph](https://hygraph.com/): The federated content platform
- [Kitemaker](https://kitemaker.co/): Product development tool built to manage the work, not the workers
- [Living Spec](https://livingspec.com/): A modern way for product teams to work
- [Netlify CMS](https://www.netlifycms.org/): Open source content management for your Git workflow
- [Notes Together](https://notestogether.hominidsoftware.com/): Get mundane details out of your head
- [Prezly](https://www.prezly.com/): Turn your audience into fans
- [Quill Forms](https://demo.quillforms.com/): Open Source Typeform Alternative WordPress Plugin
- [Sana](https://www.sanalabs.com): Reimagining learning with AI [LMS]
- [Sanity.io](https://www.sanity.io/): Platform for structured content [data driven content]
- [Slite](https://slite.com/): Where remote teams make decisions and share knowledge
- [Static CMS](https://www.staticcms.org/): Git-based CMS for Static Site Generators
- [Taskade](https://www.taskade.com/): Get work done in one unified workspace
- [TRPG Engine](https://trpg.moonrailgun.com/)
- [Thoughts](https://thoughts.teambition.com/)

## Editors

These pre-packaged editors are built on top of Slate, and can be helpful to see how you might structure your code:

- [Accord Project Markdown Editor](https://github.com/accordproject/web-components) is a WYSIWYG editor for [CommonMark](https://commonmark.org/).
- [Canner Editor](https://github.com/Canner/canner-slate-editor) is a rich text editor.
- [Chatterslate](https://github.com/chatterbugapp/chatterslate) helps teach language grammar and more at [Chatterbug](https://chatterbug.com).
- [CoCalc](https://github.com/sagemathinc/cocalc/) Collaborative Calculation editor in the Cloud
- [French Press Editor](https://github.com/roast-cms/french-press-editor) is a customizeable editor with offline support.
- [Nossas Editor](http://slate-editor.bonde.org/) is a drop-in WYSIWYG editor.
- [React Force Slate Editor](https://github.com/nareshbhatia/react-force/tree/master/packages/slate-editor) is a light-weight medium-style editor with no editor chrome.
- [React Page](https://github.com/react-page/react-page) is a self-contained, customizable inline WYSIWYG editor library.
- [Slate Plugins Next](https://github.com/zbeyens/slate-plugins-next) provides an editor with configurable and extendable plugins.
- [Tripdocs](https://github.com/ctripcorp/tripdocs): It's a modern, production-ready rich text editor.

\(Or, if you have their exact use case, can be a drop-in editor for you.\)
